/*
 *  Brno University of Technology
 *
 *  Copyright (C) 2009-2010 by Brno University of Technology and the contributors
 *
 *  Complete list of developers available at our web site:
 *
 *       http://spl.utko.feec.vutbr.cz
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/.
 */
package cz.vutbr.feec.utko.opencv.operators;

import ij.ImagePlus;
import ij.process.ColorProcessor;

import java.util.List;

import com.googlecode.javacv.cpp.opencv_core.IplImage;
import com.rapidminer.operator.Operator;
import com.rapidminer.operator.OperatorDescription;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.operator.ports.InputPort;
import com.rapidminer.operator.ports.OutputPort;
import com.rapidminer.operator.ports.metadata.MetaData;
import com.rapidminer.operator.ports.metadata.SimplePrecondition;
import com.rapidminer.parameter.ParameterType;

import cz.vutbr.feec.imageprocessing.IOObject.ImagePlusBaseIOObject;
import cz.vutbr.feec.imageprocessing.IOObject.ImagePlusClrIOObject;
import cz.vutbr.feec.utko.opencv.io.OpenCVIOObject;

/**
 * The Class OpenCVToColorImage.
 */
public class OpenCVToColorImage extends Operator {

	private OutputPort outImageJ = getOutputPorts().createPort("color image");
	private InputPort inOpenCV = getInputPorts().createPort("opencv");

	public OpenCVToColorImage(OperatorDescription description) {
		super(description);
		inOpenCV.addPrecondition(new SimplePrecondition(inOpenCV, new MetaData(
				OpenCVIOObject.class)));
		getTransformer().addGenerationRule(outImageJ, ImagePlusBaseIOObject.class);

	}

	@Override
	public void doWork() throws OperatorException {
		OpenCVIOObject cvIO = inOpenCV.getData();
		IplImage cvImg = cvIO.getImage();
		
		ColorProcessor ip = new ColorProcessor(cvImg.getBufferedImage());
		ImagePlus imp = new ImagePlus("img", ip);		

		ImagePlusClrIOObject imgOut = new ImagePlusClrIOObject("opencv", imp);
		outImageJ.deliver(imgOut);
	}

	
	@Override
	public List<ParameterType> getParameterTypes() {
		List<ParameterType> p = super.getParameterTypes();
		return p;
	}
}
